package net.sf.jasperreports.charts.base;

import java.io.Serializable;
import net.sf.jasperreports.charts.JRCategorySeries;
import net.sf.jasperreports.engine.JRExpression;
import net.sf.jasperreports.engine.JRHyperlink;
import net.sf.jasperreports.engine.JRRuntimeException;
import net.sf.jasperreports.engine.base.JRBaseObjectFactory;

public class JRBaseCategorySeries implements JRCategorySeries, Serializable {
  private static final long serialVersionUID = 10200L;
  
  protected JRExpression seriesExpression = null;
  
  protected JRExpression categoryExpression = null;
  
  protected JRExpression valueExpression = null;
  
  protected JRExpression labelExpression = null;
  
  protected JRHyperlink itemHyperlink;
  
  protected JRBaseCategorySeries() {}
  
  public JRBaseCategorySeries(JRCategorySeries categorySeries, JRBaseObjectFactory factory) {
    factory.put(categorySeries, this);
    this.seriesExpression = factory.getExpression(categorySeries.getSeriesExpression());
    this.categoryExpression = factory.getExpression(categorySeries.getCategoryExpression());
    this.valueExpression = factory.getExpression(categorySeries.getValueExpression());
    this.labelExpression = factory.getExpression(categorySeries.getLabelExpression());
    this.itemHyperlink = factory.getHyperlink(categorySeries.getItemHyperlink());
  }
  
  public JRExpression getSeriesExpression() {
    return this.seriesExpression;
  }
  
  public JRExpression getCategoryExpression() {
    return this.categoryExpression;
  }
  
  public JRExpression getValueExpression() {
    return this.valueExpression;
  }
  
  public JRExpression getLabelExpression() {
    return this.labelExpression;
  }
  
  public JRHyperlink getItemHyperlink() {
    return this.itemHyperlink;
  }
  
  public Object clone() {
    JRBaseCategorySeries clone = null;
    try {
      clone = (JRBaseCategorySeries)super.clone();
    } catch (CloneNotSupportedException e) {
      throw new JRRuntimeException(e);
    } 
    if (this.seriesExpression != null)
      clone.seriesExpression = (JRExpression)this.seriesExpression.clone(); 
    if (this.categoryExpression != null)
      clone.categoryExpression = (JRExpression)this.categoryExpression.clone(); 
    if (this.valueExpression != null)
      clone.valueExpression = (JRExpression)this.valueExpression.clone(); 
    if (this.labelExpression != null)
      clone.labelExpression = (JRExpression)this.labelExpression.clone(); 
    if (this.itemHyperlink != null)
      clone.itemHyperlink = (JRHyperlink)this.itemHyperlink.clone(); 
    return clone;
  }
}
